;********************************************************
;*              DX9 subsystem extensions                *
;********************************************************


  Structure PB_StructureMovie
    Movie.l          ; IGraphBuilder DirectShow pointer
    MediaControl.l   ; IMediaControl DirectShow pointer
    MediaEvent.l     ; IMediaEventEx DirectShow pointer
    Window.l         ; IVideoWindow DirectShow pointer
    Audio.l          ; IBasicAudio DirectShow pointer
    Video.l          ; IBasicVideo DirectShow pointer
    MediaSeeking.l   ; IMediaSeeking DirectShow pointer
    State.l          ; State of the movie
  EndStructure
  
  Structure MyD3DTLVERTEX
    x.f
    y.f
    z.f
    rhw.f
    Color.l
    tu.f
    tv.f
  EndStructure 
  
  Structure PB_DX9Sprite3D
    TexRes.l                    ; TexRes
    Vertice.MyD3DTLVERTEX[4]    ; The 4 vertices for the rectangle sprite
    TmpVertice.MyD3DTLVERTEX[4] ; The 4 vertices for the rectangle sprite
    Width.l			                ; width set with ZoomSprite3D()
    Height.l			              ; height set with ZoomSprite3D()
    RealWidth.l
    RealHeight.l
    Angle.f
    Transformed.l
  EndStructure
  
  Procedure DX9S_RenderMovieFrame(Movie.l,SpriteID.l)
    If SpriteID=0:ProcedureReturn #False:EndIf
    *Movie.PB_StructureMovie=IsMovie(Movie)
    If *Movie=0:ProcedureReturn #False:EndIf
    *Video.IBasicVideo=*Movie\Video
    *Video\GetCurrentImage(@Size,0)
    *ptr.BITMAPINFOHEADER=GlobalAlloc_(#GMEM_FIXED,Size)
    If *ptr=0:ProcedureReturn #False:EndIf
    *Video\GetCurrentImage(@Size,*ptr)
    
    VTable=PeekL(SpriteID)
    If VTable=0:ProcedureReturn 0:EndIf
    
    DC=CallFunctionFast(PeekL(VTable+36),SpriteID); GetDC
    If DC=0:GlobalFree_(*ptr):ProcedureReturn #False:EndIf
    Result=SetDIBitsToDevice_(DC,0,0,*ptr\biWidth,*ptr\biHeight,0,0,0,*ptr\biHeight,*ptr+SizeOf(BITMAPINFOHEADER),*ptr,0)
    CallFunctionFast(PeekL(VTable+40),SpriteID,0); ReleaseDC
    GlobalFree_(*ptr)
    ProcedureReturn Result
  EndProcedure
  
  
  Procedure DX9S_ClipSprite3D(Sprite3D.l,ClipX.l,ClipY.l,ClipWidth.l,ClipHeight.l)
    *ptr.PB_DX9Sprite3D=IsSprite3D(Sprite3D)
    If *ptr=0:ProcedureReturn #False:EndIf
    
    If ClipX<0:ClipX=0:EndIf
    If ClipY<0:ClipY=0:EndIf
    
    If ClipWidth<0:ClipWidth=0:EndIf
    If ClipHeight<0:ClipHeight=0:EndIf
    
    If ClipX>*ptr\RealWidth:ClipX=*ptr\RealWidth:EndIf
    If ClipY>*ptr\RealHeight:ClipY=*ptr\RealHeight:EndIf
    
    If ClipX+ClipWidth>*ptr\RealWidth:ClipWidth=*ptr\RealWidth-ClipX:EndIf
    If ClipY+ClipHeight>*ptr\RealHeight:ClipHeight=*ptr\RealHeight-ClipY:EndIf
    
    *ptr\Vertice[0]\tu=ClipX/*ptr\RealWidth
    *ptr\Vertice[0]\tv=ClipY/*ptr\RealHeight 
    
    *ptr\Vertice[1]\tu=(ClipX+ClipWidth)/*ptr\RealWidth 
    *ptr\Vertice[1]\tv=ClipY/*ptr\RealHeight
    
    *ptr\Vertice[2]\tu=ClipX/*ptr\RealWidth 
    *ptr\Vertice[2]\tv=(ClipY+ClipHeight)/*ptr\RealHeight 
    
    *ptr\Vertice[3]\tu=(ClipX+ClipWidth)/*ptr\RealWidth 
    *ptr\Vertice[3]\tv=(ClipY+ClipHeight)/*ptr\RealHeight 
    
    ProcedureReturn #True
  EndProcedure
  
  Procedure DX9S_Sprite3DColor(Sprite3D.l,Color1.l,Color2.l,Color3.l,Color4.l)
    *ptr.PB_DX9Sprite3D=IsSprite3D(Sprite3D)
    If *ptr=0:ProcedureReturn #False:EndIf
    
    *ptr\Vertice[0]\Color=Color1
    *ptr\Vertice[1]\Color=Color2
    *ptr\Vertice[2]\Color=Color3
    *ptr\Vertice[3]\Color=Color4
    
    ProcedureReturn #True
  EndProcedure

  Procedure DX9S_GetD3DDevice9()
    ProcedureReturn CallFunctionFast(GetProcAddress_(GetModuleHandle_("DX9SubsystemDLL.dll"),"__GetD3DDevice9"))
  EndProcedure
  
  
  
  
; IDE Options = PureBasic v4.00 (Windows - x86)
; CursorPosition = 109
; FirstLine = 75
; Folding = -
; SubSystem = DX9